%last changed by MR, JE, 20150303

%% Import data %%
[filename, dir] = uigetfile('*_3DMC.sdm', 'MultiSelect','on', 'Select_3DMC.sdm:');
filename = cellstr(filename);
for i = 1:length(filename)
    s = [dir, filename{1,i}];
    fid = fopen(s);
    tline = fgetl(fid);
    while isempty(strfind(tline, 'Translation'))
        tline = fgetl(fid);
    end
    tline = fgetl(fid);
    no = 1;
    while length(tline) >= 72
        sf = strfind(tline,'.');
        if length(sf) ~= 6;
            sdm.data(no,1) = 0;
            sdm.data(no,2) = 0;
            sdm.data(no,3) = 0;
            sdm.data(no,4) = 0;
            sdm.data(no,5) = 0;
            sdm.data(no,6) = 0;
        else
            sdm.data(no,1) = str2num(tline(sf(1)-2 : sf(2)-3));
            sdm.data(no,2) = str2num(tline(sf(2)-2 : sf(3)-3));
            sdm.data(no,3) = str2num(tline(sf(3)-2 : sf(4)-3));
            sdm.data(no,4) = str2num(tline(sf(4)-2 : sf(5)-3));
            sdm.data(no,5) = str2num(tline(sf(5)-2 : sf(6)-3));
            sdm.data(no,6) = str2num(tline(sf(6)-2 : end));
        end
        no = no+1;
        tline = fgetl(fid);
    end
    
    
    %% Plot All Parameters %%
    scrsz = get(0, 'ScreenSize');
    motion = figure('color','black','Position',[1 scrsz(4)/2.2 scrsz(3) scrsz(4)/2.2]);
    c = axes;
    set(c,'FontName','times', 'FontWeight','bold', 'FontSize',12, 'XColor','w', 'YColor','w')
    set(c, 'XLim',[1 size(sdm.data,1)],'XTick',1:floor(size(sdm.data,1)/10):size(sdm.data,1) ,'XTickLabel',num2str([1:floor(size(sdm.data,1)/10):size(sdm.data,1)]'))
    set(c, 'YLim',[-ceil(max(max(abs(sdm.data)))) ceil(max(max(abs(sdm.data))))],'YTick',-ceil(max(max(abs(sdm.data)))):1:ceil(max(max(abs(sdm.data)))),'YTickLabel',num2str([-ceil(max(max(abs(sdm.data)))):1:ceil(max(max(abs(sdm.data))))]'))
    set(c,'YGrid','on')
    set(get(c,'XLabel'),'String', 'Number of Volumes','FontName','times', 'FontWeight','bold', 'FontSize',12)
    set(get(c,'YLabel'),'String', 'Motion in mm','FontName','times', 'FontWeight','bold', 'FontSize',12)
    set(c,'Color',[0 0 0]) % background color: black
    hold on
    title('Rigid Body Motion Parameters - 3 Translations, 3 Rotations','Color','w','FontName','times', 'FontWeight','bold', 'FontSize',12)
    TransX = plot(sdm.data(1:end,1),'-','color', [1 0 0],'LineWidth',2);
    TransY = plot(sdm.data(1:end,2),'-','color', [0 1 0],'LineWidth',2);
    TransZ = plot(sdm.data(1:end,3),'-','color', [0 0 1],'LineWidth',2);
    RotationX = plot(sdm.data(1:end,4),'-','color', [1 1 0],'LineWidth',2);
    RotationY = plot(sdm.data(1:end,5),'-','color', [1 0 1],'LineWidth',2);
    RotationZ = plot(sdm.data(1:end,6),'-','color', [0 1 1],'LineWidth',2);
    leg = legend('TranslationX', 'TranslationY', 'TranslationZ','RotationX','RotationY','RotationZ');
    set(leg, 'Color',[0 0 0], 'TextColor', [1 1 1],'Location','NorthEastOutside');
    
    %Save Motion Plot
    set(gcf,'PaperPosition',[-1.17 1.82 13.33 4.85])
    set(gcf, 'InvertHardCopy', 'off');
    name =[s(1:end-4),'_MotionPlot'];
    print(motion,'-dpng','-r300',name);
    close;
    
    %Define Array for Motion Axis
    MotionAxis = ['TransX'; 'TransY'; 'TransZ'; 'RotatX'; 'RotatY'; 'RotatZ'];
    
    % motion parameters of interest
    Motion.Run_Number(i) = i;
    Motion.Run_Name{1,i} = filename{1,i};
    [Motion.Maximum_Motion_ReferenceRun(i), Imaxinter(i)] = max(max(abs(sdm.data)));                          % motion max compared to first vol first run
    a = MotionAxis(Imaxinter(i),1:end);
    Motion.Maximum_Motion_ReferenceRun_Dimension{i} = a;
    [Motion.Maximum_Motion_IntraRun(i), Imaxintra(i)] = max(max(abs(sdm.data-repmat(sdm.data(1,:),size(sdm.data,1),1))));    % motion max compared to first volume within same run
    b = MotionAxis(Imaxintra(i),1:end);
    Motion.Maximum_Motion_IntraRun_Dimension{i} = b;
    [Motion.Maximum_MotionRange(i), Imaxrange(i)] = max(range(sdm.data));
    c = MotionAxis(Imaxrange(i),1:end);
    Motion.Maximum_MotionRange_Dimension{i}  = c;
    
    % visual display
    disp (' ');
    disp ('Maximum movement per run:')
    disp(['Filename: ', filename{1,i}])
    disp(['Maximum Motion with Respect to Reference Run: ', num2str(Motion.Maximum_Motion_ReferenceRun(i)), ', ', MotionAxis(Imaxinter(i),1:end)])
    disp(['Maximum Motion within the Run: ', num2str(Motion.Maximum_Motion_IntraRun(i)), ', ', MotionAxis(Imaxintra(i),1:end)])
    disp(['Maximum Motion Range within the Run: ', num2str(Motion.Maximum_MotionRange(i)), ', ', MotionAxis(Imaxrange(i),1:end)])
    clear sdm
    
end
save ([dir, 'Motion.mat'], 'Motion');
clear

